"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DevTask = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _stripAnsi() {
  const data = _interopRequireDefault(require("strip-ansi"));

  _stripAnsi = function _stripAnsi() {
    return data;
  };

  return data;
}

function _iconvLite() {
  const data = _interopRequireDefault(require("iconv-lite"));

  _iconvLite = function _iconvLite() {
    return data;
  };

  return data;
}

var _Base = require("./Base");

var _enums = require("../enums");

var _util = require("../../util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class DevTask extends _Base.BaseTask {
  constructor(opts) {
    super(opts);
    this.started = false;
    this.localUrl = '';
    this.lanUrl = '';
    this.type = _enums.TaskType.DEV;
  }

  run(env = {}) {
    var _this = this,
        _superprop_callRun = (..._args) => super.run(..._args);

    return _asyncToGenerator(function* () {
      yield _superprop_callRun();
      _this.proc = (0, _util.runCommand)(_this.getScript(), {
        cwd: _this.cwd,
        env // 前端传入的 env

      });

      _this.handleChildProcess(_this.proc);
    })();
  }

  cancel() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      _this2.started = false;
      const proc = _this2.proc;

      if (!proc) {
        return;
      } // 子任务执行结束


      if ([_enums.TaskState.FAIL].indexOf(_this2.state) > -1) {
        return;
      }

      _this2.state = _enums.TaskState.INIT;
      proc.kill('SIGINT');
    })();
  }

  getDetail() {
    return _objectSpread({}, super.getDetail(), {
      started: this.started,
      localUrl: this.localUrl,
      lanUrl: this.lanUrl
    });
  }

  handleChildProcess(proc) {
    const stdoutSream = _iconvLite().default.decodeStream('utf8');

    proc.stdout.pipe(stdoutSream);
    stdoutSream.on('data', log => {
      this.emit(_enums.TaskEventType.STD_OUT_DATA, log);
      this.guessStart(log);
    });

    const stderrStream = _iconvLite().default.decodeStream('utf8');

    proc.stderr.pipe(stderrStream);
    stderrStream.on('data', log => {
      this.emit(_enums.TaskEventType.STD_ERR_DATA, log);
    });
    proc.on('exit', (code, signal) => {
      this.state = code === 1 ? _enums.TaskState.FAIL : _enums.TaskState.INIT;
      this.emit(_enums.TaskEventType.STATE_EVENT, this.state);
    }); // TODO: 这儿缺少信号

    process.on('exit', () => {
      proc.kill();
    });
  }

  getScript() {
    let command = '';

    if ((0, _util.isScriptKeyExist)(this.pkgPath, 'start')) {
      command = 'npm start';
    } else if ((0, _util.isScriptKeyExist)(this.pkgPath, 'dev')) {
      command = 'npm run dev';
    } else if (this.isBigfishProject) {
      command = 'bigfish dev';
    } else {
      command = 'umi dev';
    }

    return command;
  }

  guessStart(msg) {
    if (this.started) {
      return;
    }

    if (!/running/.test(msg)) {
      return;
    }

    this.started = true;

    const _stripAnsi$split = (0, _stripAnsi().default)(msg).split('\n'),
          _stripAnsi$split2 = _slicedToArray(_stripAnsi$split, 3),
          localStr = _stripAnsi$split2[1],
          lanStr = _stripAnsi$split2[2];

    this.localUrl = this.parseUrl(localStr);
    this.lanUrl = this.parseUrl(lanStr);
    this.state = _enums.TaskState.SUCCESS;
    this.emit(_enums.TaskEventType.STATE_EVENT, this.state);
  }

  parseUrl(str) {
    if (!str) {
      return '';
    }

    const hIndex = str.indexOf('h');
    const slashIndex = str.lastIndexOf('/');
    return str.substr(hIndex, slashIndex - hIndex);
  }

}

exports.DevTask = DevTask;