"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Dev = _interopRequireDefault(require("./ui/components/Dev"));

var _Build = _interopRequireDefault(require("./ui/components/Build"));

var _Lint = _interopRequireDefault(require("./ui/components/Lint"));

var _Test = _interopRequireDefault(require("./ui/components/Test"));

var _Install = _interopRequireDefault(require("./ui/components/Install"));

var _util = require("./ui/util");

var _enums = require("./server/core/enums");

var _uiModule = _interopRequireDefault(require("./ui/ui.module.less"));

var _enUS = _interopRequireDefault(require("./locales/en-US"));

var _zhCN = _interopRequireDefault(require("./locales/zh-CN"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _default = function _default(api) {
  var _SCRIPTS;

  (0, _util.initApiToGloal)(api);
  var intl = api.intl;
  var TwoColumnPanel = api.TwoColumnPanel,
      callRemote = api.callRemote;
  var imgProperty = {
    width: '32',
    height: '32'
  };
  var SCRIPTS = (_SCRIPTS = {}, _defineProperty(_SCRIPTS, _enums.TaskType.DEV, {
    key: 'dev',
    title: 'org.umi.ui.tasks.dev',
    icon: _react.default.createElement("img", _extends({}, imgProperty, {
      src: "https://gw.alipayobjects.com/zos/basement_prod/6000d285-334d-4513-a405-2d9f890f56e9.svg"
    })),
    description: 'org.umi.ui.tasks.dev.desc',
    Component: _Dev.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.BUILD, {
    key: 'build',
    title: 'org.umi.ui.tasks.build',
    icon: _react.default.createElement("img", _extends({}, imgProperty, {
      src: "https://gw.alipayobjects.com/zos/basement_prod/6000d285-334d-4513-a405-2d9f890f56e9.svg"
    })),
    description: 'org.umi.ui.tasks.build.desc',
    Component: _Build.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.LINT, {
    key: 'lint',
    title: 'org.umi.ui.tasks.lint',
    icon: _react.default.createElement("img", _extends({}, imgProperty, {
      src: "https://gw.alipayobjects.com/zos/basement_prod/fb3b6fab-253e-41fc-981a-8bfc5dc4fede.svg"
    })),
    description: 'org.umi.ui.tasks.lint.desc',
    Component: _Lint.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.TEST, {
    key: 'test',
    title: 'org.umi.ui.tasks.test',
    icon: _react.default.createElement("img", _extends({}, imgProperty, {
      src: "https://gw.alipayobjects.com/zos/basement_prod/f0d64a31-1767-4ab7-a7f9-eea044d92ce3.svg"
    })),
    description: 'org.umi.ui.tasks.test.desc',
    Component: _Test.default
  }), _defineProperty(_SCRIPTS, _enums.TaskType.INSTALL, {
    key: 'install',
    title: 'org.umi.ui.tasks.install',
    icon: _react.default.createElement("img", _extends({}, imgProperty, {
      src: "https://gw.alipayobjects.com/zos/basement_prod/d9fbc2fa-5bb6-46f4-bd15-385a94bc6d1c.svg"
    })),
    description: 'org.umi.ui.tasks.install.desc',
    Component: _Install.default
  }), _SCRIPTS); // 插件初始化

  callRemote({
    type: 'plugin/init'
  });
  api.listenRemote({
    type: 'org.umi.task.log',
    onMessage: function onMessage(_ref) {
      var _ref$log = _ref.log,
          log = _ref$log === void 0 ? '' : _ref$log,
          taskType = _ref.taskType;

      if (!log) {
        return;
      }

      (0, _util.getTerminalIns)(taskType).write(log.replace(/\n/g, '\r\n'));
    }
  }); // 全局通知

  api.listenRemote({
    type: 'org.umi.task.state',
    onMessage: function onMessage(_ref2) {
      var result = _ref2.detail,
          type = _ref2.taskType;
      var state = result.state;

      if ([_enums.TaskState.INIT, _enums.TaskState.ING].indexOf(state) > -1) {
        return;
      }

      var _getNoticeMessage = (0, _util.getNoticeMessage)(type, state),
          title = _getNoticeMessage.title,
          message = _getNoticeMessage.message,
          rest = _objectWithoutProperties(_getNoticeMessage, ["title", "message"]);

      api.notify(_objectSpread({
        title: "".concat(api.currentProject.name, " ").concat(intl({
          id: title
        })),
        message: intl({
          id: message
        })
      }, rest));
    }
  });

  var TasksView = function TasksView() {
    return _react.default.createElement(TwoColumnPanel, {
      sections: Object.keys(SCRIPTS).map(function (taskType) {
        var _SCRIPTS$taskType = SCRIPTS[taskType],
            key = _SCRIPTS$taskType.key,
            title = _SCRIPTS$taskType.title,
            icon = _SCRIPTS$taskType.icon,
            description = _SCRIPTS$taskType.description,
            Component = _SCRIPTS$taskType.Component;
        return {
          key: key,
          title: title,
          icon: icon,
          description: description,
          component: function component() {
            return _react.default.createElement("div", {
              className: _uiModule.default.section
            }, _react.default.createElement(Component, {
              api: api
            }));
          }
        };
      })
    });
  };

  api.addLocales({
    'zh-CN': _zhCN.default,
    'en-US': _enUS.default
  });
  api.addPanel({
    title: 'org.umi.ui.tasks.title',
    path: '/tasks',
    icon: {
      type: 'project',
      theme: 'filled'
    },
    component: TasksView
  });
};

exports.default = _default;